import sys
import re

from gi.repository import Gio
from gi.repository import GLib

from ..utils.gnomescreensaver import is_screensaver_mode


class SessionIdle(object):

    def __init__(self):
        self.is_screensaver = is_screensaver_mode()
        self.is_service_active = True
        self.service_known_times = 0
        self.pattern_service_unknown = re.compile(r"org\.freedesktop\.DBus\.Error\.ServiceUnknown")

        try:
            bus = Gio.bus_get_sync(Gio.BusType.SESSION, None)
            self.proxy = Gio.DBusProxy.new_sync(
                bus, Gio.DBusProxyFlags.NONE, None, 
                'org.gnome.ScreenSaver',
                '/org/gnome/ScreenSaver', 
                'org.gnome.ScreenSaver', None)
        except:
            print ("Exception: %s" % sys.exc_info()[1])

    def check(self):
        status = False

        try:
            status = False if self.is_screensaver else ( self.is_service_active and self.proxy.GetActive() )
        except AttributeError:
            pass
        except GLib.Error:
            errormsg = str(sys.exc_info()[1])
            print ("Exception: %s" % errormsg)
            if self.pattern_service_unknown.search(errormsg):
                self.service_known_times += 1
                if self.service_known_times >= 3:
                    print ("Disabling idle status polling.")
                    self.is_service_active = False
        except:
            print ("Exception: %s" % sys.exc_info()[1])

        # print status
        return status
